        subroutine hop(etot1d,ek1d,v1d,dir,r,v,ead,prob,
     &                 natom,nsurf,is0,is1,keyhop,kavail)
        implicit none
*
*       etot1d: energy for hopping direction(input)
*       ek1d:   kinetic energy for hopping direction(input)
*       v1d: velocity to hopping direction (input)
*       dir: direction (input)
*       r: coordinates now
*       v: velocities now
*       ead: adiabatic energies in lower and upper potentials (input)
*       prob: transition probability (output)
*       keyhop: type 1-2 for LZ
*                    3-5 for NT
*       kavail=1: Etot1d is not enough to hop vertically (output)
*
        real*8 etot1d,ek1d,v1d
        real*8 dir(*),r(*),v(*),ead(*)
        real*8 prob
        integer natom,nsurf,is0,is1,keyhop,kavail
*
        real*8 t10,t20,ex,rb,eb,rt,et,t1,t2,t1l,t1r 
        real*8 eup_t10,elow_t10,eup_t20,elow_t20,eup_r0,elow_r0 
        real*8 gamma,aa,del11,del22 
        common/ppsmbig/t10,t20,ex
        real*8 e_r0
        common/psmbig/e_r0(2)
*
        real*8 sigma,delta,r0,bf
        integer ierr,key1,key2,ilower,iupper
*
        write(*,*)'inside hop'
*
        iupper=max(is0,is1)
        ilower=min(is0,is1)
        write(*,*) 'is0,is1,iupper,ilower=',is0,is1,iupper,ilower
        write(*,*) 'ead='
        call outvec(ead,nsurf)
*
        prob=0.d0
        keyhop=0
        kavail=0
        write(*,*) 'etot1d,ead(iupper)=',etot1d,ead(iupper)
        if(etot1d < ead(iupper)) kavail=1 !Etot1D not enough to hop vertically
        delta=ead(iupper)-ead(ilower)
        write(*,'(a,2i3,1p3e12.4)') 'iupper,ilower,ead,delta=',
     &              iupper,ilower,ead(iupper),ead(ilower),delta
*
        call  findR0_LZ_NT(sigma,delta,dir,r,R0,ead,etot1d,
     &                    natom,nsurf,ilower,iupper,ierr,
     &       ex,eup_t10,elow_t10,eup_t20,elow_t20,eup_r0,elow_r0,
     &                    gamma,aa,del11,del22,is0,t1,t2,t1l,t1r,
     &                    t10,t20,rb,eb,rt,et,key1,key2)
        write(*,*)'R0=',R0
        if(ierr.eq.1)then
        write(*,*)'cannot find r0'
        return
        endif
*
*       pot1d is calculated in findR0 already
*
*       call pot1d(u0,r0,dir,ead,natom,nsurf)
*
        e_r0(1)=ead(ilower)
        e_r0(2)=ead(iupper)
*
        write(*,*) 'key1,key2=',key1,key2
*
        if(key1+key2 == 0) then

          write(*,*) 't10,t20=',t10,t20 
          write(*,*) 't1,t2=',t1,t2 
          write(*,*)'going into LZ'
          call LZ(etot1d,ex,r0,dir,r,t10,t20,prob,
     &            natom,nsurf,ilower,iupper,keyhop,
     &       eup_t10,elow_t10,eup_t20,elow_t20,eup_r0,elow_r0,
     &            sigma,delta) 
*
          write(*,*)'out of LZ'
*
        else
*
          write(*,*) 'et,eb=',et,eb 
          write(*,*) 'rt,rb=',rt,rb 
          write(*,*)'going into NT'
          call NT(etot1d,v1d,dir,r,r0,prob,
     &            natom,nsurf,ilower,iupper,keyhop,
     &            rb,eb,rt,et,sigma,delta,gamma,aa,
     &            t1,t2,t1l,t1r,is0,del11,del22) 
*         
          write(*,*)'out of NT'
*
        endif
*
        write(*,*) 'delta,prob,keyhop=',delta,prob,keyhop
*
        return
        end
