      subroutine run_molpro(r_c,v_c,dvdx_c,nacme_c,tdm_c,
     &                      natom,nsurf,isurf1,isurf2,indgna)
      implicit none
*
      integer natom,nsurf
      integer isurf1,isurf2,indgna
      real*8 r_c(3,*),v_c(*),dvdx_c(3,*),nacme_c(3,*)
      real*8 tdm_c(3,*)
*
*     indgna=0: energy only
*     indgna=1: energy & gradients
*     indgna=2: energy & non-adiabatic couplings
*     indgna=3: energy & difference of gradients
*     indgna=4: energy & gradients & hessian
*
      include 'para.inc'
*
      integer, parameter :: idbg=0,niter=5
      integer not_conv,iter
*
      if (idbg == 1) then
        write(*,*) 'isurf1,isurf2,indgna in run_molpro=',
     &              isurf1,isurf2,indgna
        write(*,*) 'rc in run_molpro'
        call outrxyz(r_c,natom)
      endif
*
      call molpro_inp(r_c,natom,isurf1,isurf2,indgna)
*     write(*,*) 'Before molpro_run'
*
      loopruniter: do iter=1,niter
*
        call molpro_run
*       write(*,*) 'After  molpro_run'
*
        not_conv=0
        call molpro_out(r_c,v_c,dvdx_c,nacme_c,tdm_c,
     &                  natom,nsurf,isurf1,isurf2,indgna,not_conv)
*
*      call writemdcrd(natom,r_c) ! added by WCC
*
        if (not_conv == 0) exit loopruniter
      enddo loopruniter
*
      if (not_conv == 1) then
        write(*,*) 'Not converged in MO calculations...  niter =',niter
        stop 'Not converged in MO calculations in run_molpro'
      endif
*
*     stop 'end of run_molpro'
*
      end
